Index: /java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 87)
@@ -33,5 +33,5 @@
 	protected void run() {
 		super.run();
-		root = new Node((CompositeParam) Param.build().name("Instance").id(name).type("o").finish(), null);
+		root = new Node(Param.build().name("Instance").id(name).type("o"), null);
 		com.framsticks.model.Package.register(registry);
 	}
@@ -267,5 +267,5 @@
 		if ("/".equals(file.getPath())) {
 			if (root.getParam().getContainedTypeName() == null) {
-				root = new Node((CompositeParam)Param.build().name("Instance").id(name).type("o " + framsClass.getId()).finish(), root.getObject());
+				root = new Node(Param.build().name("Instance").id(name).type("o " + framsClass.getId()), root.getObject());
 			}
 		}
@@ -306,4 +306,5 @@
 
 					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
+					//TODO listAccessParam
 					Param param = Param.build().type("o " + accessInterface.getId()).id(id).finish();
 					Object child = accessInterface.getSelected();
@@ -339,5 +340,5 @@
 
 	public Path getPath(String textual) {
-		return new Path(this, textual);
+		return Path.build().resolve(this, textual).finish();
 	}
 
Index: /java/main/src/main/java/com/framsticks/core/ListChange.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 87)
@@ -1,16 +1,12 @@
 package com.framsticks.core;
 
-import com.framsticks.params.FramsClass;
-import com.framsticks.params.Param;
-import com.framsticks.params.types.DecimalParam;
-import com.framsticks.params.types.EnumParam;
-import com.framsticks.params.types.StringParam;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.lang.Strings;
-
-import java.util.Arrays;
 
 /**
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class ListChange {
 
@@ -31,18 +27,29 @@
 		Remove,
 		Modify
+		// Add(0),
+		// Remove(1),
+		// Modify(2);
+
+		// public final int value;
+
+		// /**
+		//  * @param value
+		//  */
+		// Action(int value) {
+		// 	this.value = value;
+		// }
+
 	}
 
-	private Action action;
-	private Integer position;
-	private String identifier;
+	public Action action = Action.Add;
+	@ParamAnnotation(id = "pos")
+	public Integer position;
+	@ParamAnnotation(id = "id")
+	public String identifier;
 
+	@ParamAnnotation
 	public Integer getType() { return action.ordinal(); }
+	@ParamAnnotation
 	public void setType(Integer type) { action = Action.values()[type]; }
-
-	public Integer getPos() { return position; }
-	public void setPos(Integer pos) { position = pos; }
-
-	public String getId() { return identifier; }
-	public void setId(String id) { identifier = id; }
 
 	public String getBestIdentifier() {
@@ -53,11 +60,4 @@
 	}
 
-	public static FramsClass getFramsClass() {
-		return new FramsClass("ListChange", "ListChange", null)
-				.append(Param.build().id("type").name("type").type(new EnumParam(Arrays.asList("Add", "Remove", "Modify"))))
-				.append(Param.build().id("id").name("identifier").type(StringParam.class))
-				.append(Param.build().id("pos").name("position").type(DecimalParam.class));
-	}
-
 	@Override
 	public String toString() {
Index: /java/main/src/main/java/com/framsticks/core/Node.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Node.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/core/Node.java	(revision 87)
@@ -1,33 +1,42 @@
 package com.framsticks.core;
 
+import javax.annotation.Nonnull;
+import javax.annotation.concurrent.Immutable;
+
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.ParamBuilder;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public class Node {
 
-    protected final CompositeParam param;
-    protected final Object object;
-    //protected final Map<String, Node> children = new HashMap<String, Node>();
+	protected final CompositeParam param;
+	protected final Object object;
+	//protected final Map<String, Node> children = new HashMap<String, Node>();
 
-    public Node() {
-        param = null;
-        object = null;
-    }
+	public Node() {
+		param = null;
+		object = null;
+	}
 
-    public Node(CompositeParam param, Object object) {
-        assert param != null;
-        this.param = param;
-        this.object = object;
-    }
+	public Node(@Nonnull CompositeParam param, Object object) {
+		assert param != null;
+		this.param = param;
+		this.object = object;
+	}
 
-    public final CompositeParam getParam() {
-        return param;
-    }
+	public Node(@Nonnull ParamBuilder builder, Object object) {
+		this((CompositeParam) builder.finish(), object);
+	}
 
-    public final Object getObject() {
-        return object;
-    }
+	public final CompositeParam getParam() {
+		return param;
+	}
+
+	public final Object getObject() {
+		return object;
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Path.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/core/Path.java	(revision 87)
@@ -11,5 +11,4 @@
 
 import javax.annotation.concurrent.Immutable;
-import javax.annotation.Nonnull;
 
 import org.apache.commons.collections.ListUtils;
@@ -19,12 +18,12 @@
  */
 @Immutable
-public class Path {
+public final class Path {
 	// private final static Logger log = Logger.getLogger(Path.class.getName());
 
-	final LinkedList<Node> nodes = new LinkedList<Node>();
-	String textual;
-	Instance instance;
-
-	protected Object getKnownChild(AccessInterface access, CompositeParam param) {
+	final Instance instance;
+	final String textual;
+	final LinkedList<Node> nodes;
+
+	protected static Object getKnownChild(Instance instance, AccessInterface access, CompositeParam param) {
 		Object child = access.get(param, Object.class);
 		if (child == null) {
@@ -34,67 +33,18 @@
 	}
 
-	// public Path constructPath(Instance instance, String textual) {
-	//	assert instance.isActive();
-
-	// }
-
-	Path(Instance instance, String textual) {
-		assert instance.isActive();
+	/**
+	 * @param instance
+	 * @param textual
+	 * @param nodes
+	 */
+	Path(Instance instance, String textual, LinkedList<Node> nodes) {
 		this.instance = instance;
-
-		nodes.add(instance.root);
-		Node current = instance.root;
-
-		StringBuilder b = new StringBuilder();
-		Iterator<String> i = Instance.splitPath(textual);
-		while (i.hasNext() && current.getObject() != null) {
-			AccessInterface access = instance.registry.prepareAccess(current.getParam());
-			if (access == null) {
-				break;
-			}
-			String e = i.next();
-			Param p = access.getParam(e);
-			if (!(p instanceof CompositeParam)) {
-				//entries.add(new Entry());
-				break;
-			}
-			CompositeParam c = (CompositeParam)p;
-			b.append("/").append(e);
-			access.select(current.getObject());
-			current = new Node(c, getKnownChild(access, c));
-			nodes.add(current);
-		}
-		this.textual = (size() == 1) ? "/" : b.toString();
-	}
-
-	public Path(@Nonnull Instance instance, List<Node> nodes, Node node) {
-		this.instance = instance;
-		StringBuilder b = new StringBuilder();
-		boolean add = false;
-		for (Node n : nodes) {
-			this.nodes.add(n);
-			if (add) {
-				b.append("/").append(n.getParam().getId());
-			}
-			add = true;
-			if (n == node) {
-				break;
-			}
-		}
-		this.textual = (size() == 1) ? "/" : b.toString();
-	}
-
-	protected Path() {
-
+		this.textual = textual;
+		this.nodes = nodes;
 	}
 
 	public Path appendNode(Node node) {
 		assert isResolved();
-		Path result = new Path();
-		result.textual = textual + ((size() == 1) ? "" : "/") + node.getParam().getId();
-		result.instance = instance;
-		result.nodes.addAll(nodes);
-		result.nodes.add(node);
-		return result;
+		return new PathBuilder().instance(instance).textual(textual + ((size() == 1) ? "" : "/") + node.getParam().getId()).add(nodes).add(node).finish();
 	}
 
@@ -104,11 +54,105 @@
 	}
 
+	public static class PathBuilder {
+
+		Instance instance;
+		String textual;
+		final LinkedList<Node> nodes = new LinkedList<Node>();
+
+		public Path finish() {
+			assert instance != null;
+			assert textual != null;
+			return new Path(instance, textual, nodes);
+		}
+
+		public PathBuilder()
+		{
+		}
+
+		public PathBuilder instance(Instance instance) {
+			this.instance = instance;
+			return this;
+		}
+
+		public PathBuilder textual(String textual) {
+			this.textual = textual;
+			return this;
+		}
+
+		public PathBuilder add(List<Node> nodes) {
+			this.nodes.addAll(nodes);
+			return this;
+		}
+
+		public PathBuilder add(Node node) {
+			this.nodes.add(node);
+			return this;
+		}
+
+		public PathBuilder setLast(Object object) {
+			Node n = nodes.pollLast();
+			nodes.add(new Node(n.getParam(), object));
+			return this;
+		}
+
+		public PathBuilder buildUpTo(List<Node> nodes, Node node) {
+			StringBuilder b = new StringBuilder();
+			boolean add = false;
+			for (Node n : nodes) {
+				this.nodes.add(n);
+				if (add) {
+					b.append("/").append(n.getParam().getId());
+				}
+				add = true;
+				if (n == node) {
+					break;
+				}
+			}
+			this.textual = (nodes.size() == 1) ? "/" : b.toString();
+			return this;
+		}
+
+		public PathBuilder resolve(Instance instance, String textual) {
+
+			assert nodes.isEmpty();
+			assert instance.isActive();
+			this.instance = instance;
+
+			nodes.add(instance.root);
+			Node current = instance.root;
+
+			StringBuilder b = new StringBuilder();
+			Iterator<String> i = Instance.splitPath(textual);
+			while (i.hasNext() && current.getObject() != null) {
+				AccessInterface access = instance.registry.prepareAccess(current.getParam());
+				if (access == null) {
+					break;
+				}
+				String e = i.next();
+				Param p = access.getParam(e);
+				if (!(p instanceof CompositeParam)) {
+					//entries.add(new Entry());
+					break;
+				}
+				CompositeParam c = (CompositeParam)p;
+				b.append("/").append(e);
+				access.select(current.getObject());
+				current = new Node(c, getKnownChild(instance, access, c));
+				nodes.add(current);
+			}
+			this.textual = (nodes.size() == 1) ? "/" : b.toString();
+
+			return this;
+		}
+	}
+
+	public static PathBuilder build() {
+		return new PathBuilder();
+	}
+
 	public Path appendResolution(Object object) {
 		assert !isResolved();
-		Path result = new Path();
-		result.textual = textual;
-		result.instance = instance;
-		result.nodes.addAll(nodes);
-		result.nodes.add(new Node(result.nodes.pollLast().getParam(), object));
+		Path result = new PathBuilder().textual(textual).instance(instance).add(nodes).setLast(object).finish();
+		assert size() == result.size();
 		return result;
 	}
@@ -169,7 +213,7 @@
 		assert !isResolved();
 		if (size() == 1) {
-			return new Path(instance, "/");//appendResolution(instance.root.object);
-		}
-		Object child = getKnownChild(instance.bindAccess(getUnder()), getTop().getParam());
+			return Path.build().resolve(instance, "/").finish();//appendResolution(instance.root.object);
+		}
+		Object child = getKnownChild(instance, instance.bindAccess(getUnder()), getTop().getParam());
 		if (child == null) {
 			return this;
@@ -201,7 +245,7 @@
 	}
 
-	public void setInstance(Instance instance) {
-		this.instance = instance;
-	}
+	// public void setInstance(Instance instance) {
+	//	this.instance = instance;
+	// }
 
 	@SuppressWarnings("unchecked")
Index: /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 87)
@@ -42,9 +42,11 @@
 		Package.register(this.getRegistry());
 
-		registry.putInfoIntoCache(new FramsClass("ModelBuilderRoot", "ModelBuilderRoot", null)
-				.append(Param.build().type("o Model").id("model").name("model"))
-				.append(Param.build().type("s 1").id("genotype").name("genotype"))
+		registry.putInfoIntoCache(FramsClass.build()
+				.idAndName("ModelBuilderRoot")
+				.param(Param.build().id("model").type("o Model").name("model"))
+				.param(Param.build().id("genotype").type("s 1").name("genotype"))
+				.finish()
 		);
-		root = new Node((CompositeParam)Param.build().type("o ModelBuilderRoot").id(name).name("Instance").finish(), PropertiesAccess.createPropertiesMap());
+		root = new Node(Param.build().type("o ModelBuilderRoot").id(name).name("Instance"), PropertiesAccess.createPropertiesMap());
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/EndpointAtFrame.java	(revision 87)
@@ -121,8 +121,6 @@
 					return result;
 				}
-				Path p = new Path(path.getInstance(), nodes, n);
+				Path p = Path.build().instance(path.getInstance()).buildUpTo(nodes, n).finish();
 
-				//TODO breaks immutable
-				path.setInstance(path.getInstance());
 
 				log.debug("forced resolution: creating treenode for " + p);
Index: /java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 87)
@@ -42,5 +42,5 @@
 	}
 
-	public static Control createComponentForText(PrimitiveParam valueParam) {
+	public static Control createComponentForText(PrimitiveParam<?> valueParam) {
 		if (valueParam.getMin(Object.class) != null) {
 			return new TextAreaControl(valueParam);
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 87)
@@ -14,5 +14,5 @@
 	protected JScrollPane textScrollPane;
 
-	public TextAreaControl(PrimitiveParam valueParam) {
+	public TextAreaControl(PrimitiveParam<?> valueParam) {
 		super(valueParam);
 		textArea = new JTextArea();
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextControl.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextControl.java	(revision 87)
@@ -10,5 +10,5 @@
 public abstract class TextControl extends ValueControl {
 
-	public TextControl(PrimitiveParam valueParam) {
+	public TextControl(PrimitiveParam<?> valueParam) {
 		super(valueParam);
 	}
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 87)
@@ -23,5 +23,5 @@
 	}
 
-	public TextFieldControl(PrimitiveParam valueParam) {
+	public TextFieldControl(PrimitiveParam<?> valueParam) {
 		super(valueParam);
 		textField = new JTextField();
Index: /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 87)
@@ -22,5 +22,5 @@
 	protected ValueControlListener listener;
 
-	public ValueControl(PrimitiveParam primitiveParam) {
+	public ValueControl(PrimitiveParam<?> primitiveParam) {
 		super(primitiveParam);
 
@@ -40,6 +40,6 @@
 
 	@Override
-	public PrimitiveParam getParam() {
-		return (PrimitiveParam) param;
+	public PrimitiveParam<?> getParam() {
+		return (PrimitiveParam<?>) param;
 	}
 
Index: /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 87)
@@ -2,8 +2,6 @@
 
 import com.framsticks.core.*;
-import com.framsticks.params.CompositeParam;
 import com.framsticks.params.ConstructionException;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.FramsClassBuilder;
 import com.framsticks.params.Param;
 import com.framsticks.core.LocalInstance;
@@ -44,5 +42,5 @@
 		hosted.setName("hosted");
 		hosted.configure(hostedConfig);
-		root = new Node((CompositeParam) Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()).finish(), hosted);
+		root = new Node(Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()), hosted);
 	}
 
@@ -59,5 +57,5 @@
 		try {
 			Class<?> nativeClass = Class.forName(id);
-			FramsClass framsClass = FramsClassBuilder.buildForClass(nativeClass);
+			FramsClass framsClass = FramsClass.build().forClass(nativeClass);
 
 			if (!framsClass.getId().equals(id)) {
Index: /java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java
===================================================================
--- /java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 87)
@@ -29,6 +29,5 @@
 
 public class FavouritesXMLFactory {
-	private static final Logger log = Logger
-			.getLogger(FavouritesXMLFactory.class);
+	private static final Logger log = Logger.getLogger(FavouritesXMLFactory.class);
 
 	private static final String PATH_MARK = "path";
Index: /java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java	(revision 87)
@@ -183,5 +183,5 @@
 		StringBuilder sb = new StringBuilder();
 		sb.append("NeuroClass [getId=").append(framsClass.getId())
-				.append(", getName=").append(framsClass.getName())
+				.append(", name=").append(framsClass.getName())
 				.append(", description=").append(framsClass.getDescription())
 				.append(", groups#=").append(framsClass.getGroupCount())
Index: /java/main/src/main/java/com/framsticks/observers/Observer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 87)
@@ -7,4 +7,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.lang.Casting;
+
 import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
@@ -50,4 +51,5 @@
 	}
 
+	// @XStreamImplicit(itemFieldName = "endpoint")
 	public Endpoint addEndpointForInstance(Instance instance) {
 		Endpoint endpoint = createEndpoint();
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 87)
@@ -74,4 +74,6 @@
 	FramsClass getFramsClass();
 
+	boolean tryAutoAppend(Object object);
+
 
 }
Index: /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 87)
@@ -31,4 +31,5 @@
 	@Override
 	public Param getParam(int i) {
+		//TODO listAccessParam
 		return Param.build().id(Integer.toString(i)).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
 	}
Index: /java/main/src/main/java/com/framsticks/params/CompositeParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 87)
@@ -1,14 +1,17 @@
 package com.framsticks.params;
 
-import com.framsticks.util.lang.Strings;
+import javax.annotation.concurrent.Immutable;
 
 /**
  * @author Piotr Sniegowski
  */
+@Immutable
 public abstract class CompositeParam extends ValueParam {
+
 	protected final String containedTypeName;
 
-	public CompositeParam(String containedTypeName) {
-		this.containedTypeName = Strings.notEmpty(containedTypeName) ? containedTypeName : null;
+	public CompositeParam(ParamBuilder builder) {
+		super(builder);
+		this.containedTypeName = builder.getContainedTypeName();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 87)
@@ -8,4 +8,7 @@
 
 import javax.annotation.Nonnull;
+import javax.annotation.concurrent.Immutable;
+
+import org.apache.log4j.Logger;
 
 /**
@@ -21,12 +24,20 @@
  * @author Piotr Sniegowski
  */
+@Immutable
 @FramsClassAnnotation(id = "class", name = "class")
 public final class FramsClass {
 
-	/** The offset of the parameter (applied for newly added parameter). */
-	protected int fieldsNumber;
+	private final static Logger log = Logger.getLogger(FramsClass.class);
 
-	/** The groups. */
-	protected List<Group> groups = new ArrayList<Group>();
+	protected final String id;
+
+	protected final String name;
+
+	protected final String description;
+
+	protected final List<Group> groups;
+
+	/** The param list (for accessing parameters by offset in O(1) time. */
+	protected final List<Param> paramList;
 
 	/**
@@ -36,15 +47,6 @@
 	protected Map<String, Param> paramEntryMap = new LinkedHashMap<String, Param>();
 
-	/** The param list (for accessing parameters by offset in O(1) time. */
-	protected List<Param> paramList = new ArrayList<Param>();
-
-	/** The param getId map (for fast lookup of offset based on name */
-	protected Map<String, Integer> paramIdMap = new HashMap<String, Integer>();
-
-	protected String id;
-
-	protected String name;
-
-	protected String description;
+	// /** The param getId map (for fast lookup of offset based on name */
+	// protected Map<String, Integer> paramIdMap = new HashMap<String, Integer>();
 
 	public Collection<Param> getParamEntries() {
@@ -52,49 +54,26 @@
 	}
 
-	public FramsClass() {
+	public FramsClass(String id, String name, String description, List<Param> params, List<Group> groups) {
 
-	}
+		this.id = id;
+		this.name = name;
+		this.description = description;
+		this.groups = groups;
+		this.paramList = params;
 
-	public FramsClass(String id, String name, String description) {
-		this.setId(id);
-		this.setName(name);
-		this.setDescription(description);
-	}
+		for (Param param : params) {
+			paramEntryMap.put(param.getId(), param);
+			try {
+				Group group = groups.get(param.getGroup());
+				if (group != null) {
+					group.addProperty(param);
+				}
+			} catch (IndexOutOfBoundsException ignored) {
 
-	/**
-	 * Adds new param entry.
-	 *
-	 * @param param
-	 *            the new param entry
-	 */
-	public FramsClass append(Param param) {
-		// if (param.hasFlag(Flags.USERHIDDEN)) {
-		// 	return this;
-		// }
-		paramEntryMap.put(param.getId(), param);
-		//paramEntryMap.put(param.getInternalId(), param);
-		paramList.add(param);
-		try {
-			Group group = groups.get(param.getGroup());
-			if (group != null) {
-				group.addProperty(param);
 			}
-		} catch (IndexOutOfBoundsException ignored) {
-
 		}
 
-		return this;
-	}
+		log.trace("created framsclass " + this);
 
-	public FramsClass append(ParamBuilder builder) {
-		return append(builder.finish());
-	}
-
-	/**
-	 * Adds new group.
-	 */
-	public FramsClass appendGroup(Group group) {
-		groups.add(group);
-		return this;
 	}
 
@@ -206,20 +185,9 @@
 	@Override
 	public String toString() {
-		return id;
+		return id + "(" + name + ")";
 	}
 
-	@ParamAnnotation
-	public void setId(String id) {
-		this.id = id;
-	}
-
-	@ParamAnnotation
-	public void setName(String name) {
-		this.name = name;
-	}
-
-	@ParamAnnotation(id = "desc")
-	public void setDescription(String description) {
-		this.description = description;
+	public static FramsClassBuilder build() {
+		return new FramsClassBuilder();
 	}
 }
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 87)
@@ -7,4 +7,8 @@
 import java.lang.reflect.ParameterizedType;
 import java.lang.reflect.Type;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
@@ -12,4 +16,5 @@
 import org.apache.log4j.Logger;
 
+import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
@@ -18,8 +23,8 @@
 import com.framsticks.util.lang.Strings;
 
+@FramsClassAnnotation(id = "class", name = "class")
 public class FramsClassBuilder {
 	private static final Logger log =
 		Logger.getLogger(FramsClassBuilder.class);
-
 
 	public static String getName(FramsClassAnnotation fca, Class<?> javaClass) {
@@ -63,23 +68,40 @@
 		}
 
-		if (type.equals(Integer.class) || type.equals(int.class)) {
-			return "d";
-		}
-		if (type.equals(String.class)) {
-			return "s";
-		}
-		if (type.equals(Double.class) || type.equals(double.class)) {
-			return "f";
-		}
-		if (type.equals(Boolean.class) || type.equals(boolean.class)) {
-			return "d 0 1";
-		}
-		if (type.equals(Object.class)) {
-			return "x";
-		}
 		if (type instanceof Class) {
+
+			Class<?> cl = (Class<?>) type;
+
+			// TODO: future support for enum
+			// if (cl.isEnum()) {
+			// 	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
+			// 	Enum<?>[] enums = enumType.getEnumConstants();
+			// 	StringBuilder b = new StringBuilder();
+
+			// 	b.append("d 0 ").append(enums.length - 1).append(" 0 ");
+			// 	for (Enum<?> e : enums) {
+			// 		b.append("~").append(e.name());
+			// 	}
+			// 	return b.toString();
+			// }
+			if (cl.equals(Integer.class) || cl.equals(int.class)) {
+				return "d";
+			}
+			if (cl.equals(String.class)) {
+				return "s";
+			}
+			if (cl.equals(Double.class) || cl.equals(double.class)) {
+				return "f";
+			}
+			if (cl.equals(Boolean.class) || cl.equals(boolean.class)) {
+				return "d 0 1";
+			}
+			if (cl.equals(Object.class)) {
+				return "x";
+			}
+
 			return "o " + ((Class<?>) type).getCanonicalName();
 		}
-		return null;
+
+		throw new ConstructionException().msg("failed to find framsticks for native type").arg("type", type);
 	}
 
@@ -141,21 +163,124 @@
 	}
 
-	public static FramsClass buildForClass(Class<?> javaClass) throws ConstructionException {
+	public static Map<Class<?>, FramsClass> synchronizedCacheForBasedOnForJavaClass = Collections.synchronizedMap(new HashMap<Class<?>, FramsClass>());
+
+	public FramsClass forClass(Class<?> javaClass) throws ConstructionException {
+		FramsClass result = synchronizedCacheForBasedOnForJavaClass.get(javaClass);
+		if (result != null) {
+			return result;
+		}
+
+		log.info("building for class " + javaClass);
 
 		FramsClassAnnotation fca = javaClass.getAnnotation(FramsClassAnnotation.class);
 		if (fca == null) {
-			log.error(javaClass.getName() + " is not annotated with FramsClassAnnotation");
-			return null;
-		}
-
-		FramsClass framsClass = new FramsClass(getId(fca, javaClass), getName(fca, javaClass), "");
+			throw new ConstructionException().msg("java class is not annotated with FramsClassAnnotation").arg("java", javaClass);
+		}
+
+		id(getId(fca, javaClass));
+		name(getName(fca, javaClass));
 
 		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(javaClass);
 
 		for (ParamCandidate pc : candidates.values()) {
-			framsClass.append(Param.build().id(pc.getId()).name(pc.getName()).type(getParamTypeForNativeType(pc.getType())).flags(pc.getFlags()));
-		}
-
-		return framsClass;
-	}
+			param(Param.build().id(pc.getId()).name(pc.getName()).type(getParamTypeForNativeType(pc.getType())).flags(pc.getFlags()));
+		}
+
+		result = finish();
+
+		synchronizedCacheForBasedOnForJavaClass.put(javaClass, result);
+
+		return result;
+	}
+
+
+	protected String id;
+
+	protected String name;
+
+	protected String description;
+
+	protected final List<Param> params = new LinkedList<>();
+
+	protected List<Group> groups = new ArrayList<Group>();
+
+	@ParamAnnotation
+	public FramsClassBuilder id(String id) {
+		this.id = id;
+		return this;
+	}
+
+	@ParamAnnotation
+	public FramsClassBuilder name(String name) {
+		this.name = name;
+		return this;
+	}
+
+	public FramsClassBuilder idAndName(String v) {
+		this.id = v;
+		this.name = v;
+		return this;
+	}
+
+	@ParamAnnotation(id = "desc")
+	public FramsClassBuilder description(String description) {
+		this.description = description;
+		return this;
+	}
+
+	public FramsClassBuilder() {
+	}
+
+	public FramsClass finish() {
+		return new FramsClass(id, name, description, params, groups);
+	}
+
+	public FramsClassBuilder append(Param param) {
+		params.add(param);
+		return this;
+	}
+
+	@AutoAppendAnnotation
+	public FramsClassBuilder param(ParamBuilder builder) {
+		return append(builder.finish());
+	}
+
+	@AutoAppendAnnotation
+	public FramsClassBuilder group(Group group) {
+		groups.add(group);
+		return this;
+	}
+
+	/**
+	 * @return the id
+	 */
+	@ParamAnnotation
+	public String getId() {
+		return id;
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @return the description
+	 */
+	@ParamAnnotation(id = "desc")
+	public String getDescription() {
+		return description;
+	}
+
+	public FramsClassBuilder group(String group) {
+		return group(new Group(group));
+	}
+
+	public ParamBuilder param(String id) {
+		return new ParamBuilder(this).id(id);
+	}
+
 }
